# Copyright (c) 2011-2012 Cloudera, Inc. All rights reserved.

from cmf.monitor.json_metrics_utils import get_leaf_dict


class JsonParser(object):
  def __init__(self, json_dict):
    """
    May raise ParseError if the json structure is not what
    we expect.
    """
    self._json = json_dict
    self.namesystem = get_leaf_dict(self._json, 'dfs', 'FSNamesystem')
    self.namenode = get_leaf_dict(self._json, 'dfs', 'namenode')
    self.jvm = get_leaf_dict(self._json, 'jvm', 'metrics')
    self.rpc = get_leaf_dict(self._json, 'rpc', 'metrics')
    self.rpc_detail = get_leaf_dict(self._json, 'rpc', 'detailed-metrics')
    self.ugi = get_leaf_dict(self._json, 'ugi', 'ugi')

#
# This is what the NN json looks like:
#
SAMPLE = """
  {
    "dfs":{
      "FSDirectory":[

      ],
      "FSNamesystem":[
        [
          {
            "hostName":"dsom",
            "sessionId":""
          },
          {
            "BlockCapacity":2097152,
            "BlocksTotal":1,
            "CapacityRemainingGB":57,
            "CapacityTotalGB":273,
            "CapacityUsedGB":256,
            "CorruptBlocks":0,
            "ExcessBlocks":0,
            "FilesTotal":4,
            "MissingBlocks":0,
            "PendingDeletionBlocks":0,
            "PendingReplicationBlocks":0,
            "ScheduledReplicationBlocks":0,
            "TotalLoad":1,
            "UnderReplicatedBlocks":1
          }
        ]
      ],
      "namenode":[
        [
          {
            "hostName":"dsom",
            "sessionId":""
          },
          {
            "AddBlockOps":0,
            "CreateFileOps":2,
            "DeleteFileOps":0,
            "FileInfoOps":12,
            "FilesAppended":0,
            "FilesCreated":3,
            "FilesInGetListingOps":1,
            "FilesRenamed":0,
            "GetBlockLocations":0,
            "GetListingOps":4,
            "JournalTransactionsBatchedInSync":0,
            "SafemodeTime":961,
            "Syncs_avg_time":0,
            "Syncs_num_ops":3,
            "Transactions_avg_time":0,
            "Transactions_num_ops":7,
            "blockReport_avg_time":0,
            "blockReport_num_ops":0,
            "fsImageLoadTime":948
          }
        ]
      ]
    },
    "jvm":{
      "metrics":[
        [
          {
            "hostName":"dsom",
            "processName":"NameNode",
            "sessionId":""
          },
          {
            "gcCount":3,
            "gcTimeMillis":43,
            "logError":0,
            "logFatal":0,
            "logInfo":76,
            "logWarn":3,
            "maxMemoryM":888.9375,
            "memHeapCommittedM":149.9375,
            "memHeapUsedM":70.99515,
            "memNonHeapCommittedM":23.1875,
            "memNonHeapUsedM":17.999588,
            "threadsBlocked":1,
            "threadsNew":2,
            "threadsRunnable":3,
            "threadsTerminated":4,
            "threadsTimedWaiting":5,
            "threadsWaiting":6
          }
        ]
      ]
    },
    "rpc":{
      "detailed-metrics":[
        [
          {
            "hostName":"dsom",
            "port":"8020"
          },
          {
            "create_avg_time":0,
            "create_num_ops":2,
            "getFileInfo_avg_time":0,
            "getFileInfo_num_ops":12,
            "getListing_avg_time":0,
            "getListing_num_ops":4,
            "getProtocolVersion_avg_time":0,
            "getProtocolVersion_num_ops":22,
            "mkdirs_avg_time":0,
            "mkdirs_num_ops":1,
            "renewLease_avg_time":0,
            "renewLease_num_ops":2,
            "versionRequest_avg_time":0,
            "versionRequest_num_ops":14
          }
        ]
      ],
      "metrics":[
        [
          {
            "hostName":"dsom",
            "port":"8020"
          },
          {
            "NumOpenConnections":0,
            "ReceivedBytes":10210,
            "RpcProcessingTime_avg_time":10,
            "RpcProcessingTime_num_ops":57,
            "RpcQueueTime_avg_time":1,
            "RpcQueueTime_num_ops":57,
            "SentBytes":23657,
            "callQueueLen":0,
            "rpcAuthenticationFailures":0,
            "rpcAuthenticationSuccesses":0,
            "rpcAuthorizationFailures":0,
            "rpcAuthorizationSuccesses":25
          }
        ]
      ]
    },
    "ugi":{
      "ugi":[
        [
          {
            "hostName":"dsom"
          },
          {
            "loginFailure_avg_time":0,
            "loginFailure_num_ops":0,
            "loginSuccess_avg_time":0,
            "loginSuccess_num_ops":0
          }
        ]
      ]
    }
  }
  """
